#
# spex.pm - mkprimer module for the Spex PROMELA primer
# will be ``required'' by the mkprimer program
#
# $Id: spex.pm,v 1.1.2.3 2007/03/27 15:14:16 belinfan Exp $
# <Axel.Belinfante@cs.utwente.nl>, 2007
#
#
# ======================================
package spex;

$expsuffix = '.tx';

%suffix = (
			".spex"   =>   "SPEX",
	     );

%lang = (
	"SPEX" =>
	 sub  {
		my($specfile, $target, $prefix, $libdir,
		   $specpath, $specname, $specsuffix, $exesuffix, $paramsref) = @_;
		my($error, $cmd, $flag);
        my(%params) = %$paramsref;
        if ($params{config} ne "") {
            if ($params{config} !~ /^\//) {
                $params{config} = '\\$d/'.$params{config};
            }
            $flag = '-f '.$params{config};
        }
		my(@cmds) = (
			"spexmake $specfile",
			"mv spex$exesuffix $target$expsuffix$exesuffix",
            "echo '#!/bin/sh' > $target",
            "echo 'd=`echo \$0|sed '\"'\"'s/[^\/]*\$//'\"'\"' `' >> $target",
            "echo exec primer $flag \\\"\\\$@\\\" '\$d/'$target$expsuffix$exesuffix >> $target",
            "chmod 755 $target",
		          );
		::Exec(@cmds);
	},
);

::Register(\%lang, \%suffix);

1;
