# =========================================================================
# $Id: hide_show.tcl,v 1.1.2.5 2000/11/14 11:04:39 belinfan Exp $
# =========================================================================

proc WcHide { window {e {}} w {ignored {}} } {
	global wcl
	set path [WcFullNameToWidget "." $w]
	if [winfo exists $path] {
		wcDoHide $path
	} else {
		puts stderr "WcHide: no such window: $w"
	}
}

proc WcShow { window {e {}} w {ignored {}} } {
	set path [WcFullNameToWidget "." $w]
	if [winfo exists $path] {
		wcDoShow $path
	} else {
		puts stderr "WcShow: no such window: $w"
	}
}

# =========================================================================

# below, we depend critcally on the fact that first two elements of
# the result of [pack info slave] are: -in master
proc wcDoHide { w } {
	global wcl
	if [winfo exists $w] {
		if {![info exists wcl(pack,info,$w)]} {
			if {![catch {pack info $w} info]} {
				set wcl(pack,info,$w) $info
			} else {
				Debug_Msg wcDoHide "not packed: $w"
			}
		}
		if {[info exists wcl(pack,info,$w)]} {
			set master [lindex $wcl(pack,info,$w) 1]
			Debug_Msg wcDoHide "master == $master"
			if {![info exists wcl(pack,slaves,$master)]} {
				set wcl(pack,slaves,$master) [pack slaves $master]
			}
			Debug_Msg wcDoHide "wcl(pack,slaves,$master) == $wcl(pack,slaves,$master)"
			Debug_Msg wcDoHide "about to 'pack forget $w'"
			pack forget $w
		} else {
			Debug_Msg wcDoHide "no wcl(pack,info,$w)"
		}
	} else {
		Debug_Msg wcDoHide "no such window: $w"
	}
}

proc wcDoShow { w } {
	global wcl
	if [winfo exists $w] {
		if {[info exists wcl(pack,info,$w)]} {
			set master [lindex $wcl(pack,info,$w) 1]
			set cur_slaves [pack slaves $master]
			set command $wcl(pack,info,$w)
			set neighbour [wcFindNeighbour              \
			                  $w                        \
			                  $wcl(pack,slaves,$master) \
			                  $cur_slaves ]
			if {[llength $neighbour] == 2} {
				if {[lindex $neighbour 0] > 0} {
					set command [lreplace $command 0 0 -before ]
				} else {
					set command [lreplace $command 0 0 -after ]
				}
				set command [lreplace $command 1 1 [lindex $neighbour 1]]
			}
			set command [linsert $command 0 pack configure $w]
			Debug_Msg wcDoShow "about to eval ($command)"
			eval $command
		} else {
			Debug_Msg wcDoShow "no wcl(pack,info,$w)"
		}
	} else {
		Debug_Msg wcDoShow "no such window: $w"
	}
}

# we will try to do some kind of binary search to
# find back a neighbour of e in orig in cur.
# return {-1 n} for neighbour left of e;
# return {1 n} for neighbour right of e;
# return empty list if no neighbour found.
proc wcFindNeighbour { e orig cur } {
	set l [llength $orig]
	set i [lsearch -exact $orig $e]
	# this gives us a 'pivot' in the array.
	# now try to find back element before i and after i
	# until we find a match or hit end of list in orig
	set left [expr $i - 1]
	set right [expr $i + 1]
	set progress 1
	set result {}
	while {$progress} {
		set progress 0
		if {$left >= 0} {
			set progress 1
			set li [lindex $orig $left]
			if {[lsearch -exact $cur $li] >= 0} {
				set result [list -1 $li]
				break
			}
			incr left -1
		}
		if {$right < $l} {
			set progress 1
			set ri [lindex $orig $right]
			if {[lsearch -exact $cur $ri] >= 0} {
				set result [list 1 $ri]
				break
			}
			incr right 1
		}
	}
	return $result
}



# =========================================================================
