#! /bin/sh
# $Id: primexp.sh,v 1.1.2.5 2002/03/15 14:19:11 belinfan Exp $

program=`basename $0`
USAGE="usage: $program [ -i input1,g2,... ] [ -o output1,g2,... ] [ -s seed ] [ -d Delta ] [ -[aS] ioco,sim,traces ] [-t input,output ] [ -f configfile ] [-D explorer-rundir] explorer [arguments]"

unset INGATES
unset OUTGATES
unset SEED
unset DELTA
unset CONFIGFILE
unset SUSPENSION
unset EXPLORER
unset RUNDIR
unset ALGORITHM
unset IOCT
unset COMPLETE

set -- `getopt i:o:s:d:f:t:S:a:C:T $*`
if [ $? != 0 ]; then
	echo $USAGE 1>&2
	exit 2
fi

for i in $*
do
	case $i in
		-i)  INGATES=$2;       shift 2;;
		-o)  OUTGATES=$2;      shift 2;;
		-s)  SEED=$2;          shift 2;;
		-d)  DELTA=$2;         shift 2;;
		-a)  ALGORITHM=$2;     shift 2;;
		-S)  ALGORITHM=$2;     shift 2;;
		-D)  RUNDIR=$2;        shift 2;;
		-f)  CONFIGFILE=$2;    shift 2;;
		-t)  SUSPENSION=$2;    shift 2;;
		-T)  IOCT=1;           shift;;
		-C)  COMPLETE=$2;      shift 2;;
		--)                    shift; break;;
	esac
done

#case $# in
#	1) crfile=$1;  shift;;
#	*) ;;
#esac
EXPLORER="$@"

missing_parameters=0
if [ "X$INGATES" = X ]; then
	: missing_parameters=1
	INGATES=""
fi
if [ "X$OUTGATES" = X ]; then
	: missing_parameters=1
	OUTGATES=""
fi
if [ "X$SEED" = X ]; then
	SEED=0
fi
if [ "X$DELTA" = X ]; then
	DELTA=Delta
fi
if [ "X$ALGORITHM" = X ]; then
	ALGORITHM=""
fi
if [ "X$IOCT" = X ]; then
	IOCT="0"
fi
if [ "X$COMPLETE" = X ]; then
	COMPLETE=""
fi
if [ "X$SUSPENSION" = X ]; then
	SUSPENSION=""
fi
if [ "X$RUNDIR" = X ]; then
	RUNDIR="."
fi
if [ "X$EXPLORER" = X ]; then
	missing_parameters=1
	EXPLORER=""
fi
if [ $missing_parameters = 1 ]; then
	echo $USAGE 1>&2
	exit 2
fi

export INGATES
export OUTGATES
export SEED
export DELTA
export ALGORITHM
export CONFIGFILE
export IOCT
export COMPLETE
export SUSPENSION
export RUNDIR
export EXPLORER

exec primer
