# =========================================================================
# $Id: next.tcl,v 1.1.2.8 2000/09/12 15:48:29 belinfan Exp $
# =========================================================================

proc primer_next {kind ev chan} {
	set newS {}
	set matches [try_predicates [try_instantiate $kind $ev $chan]]
	foreach m $matches {
		set sm_ev [lindex $m 0]
		set preds [lindex $m 1]
		if {[string compare $preds ""] != 0} {
			transmit_predicates $sm_ev
			add_to_goal $preds
			set res [solve_goal]
			set res_ok [lindex $res 0]
			set next_sol [lindex $res 1]
			set txt [lindex $res 2]
			set msg [lindex $res 3]
			set err [lindex $res 4]
			set sol [lindex $res 5]
			if {$res_ok > 0} {
				set new_ev [instantiate_event]
				lappend newS $new_ev
			}
		} else {
			lappend newS $sm_ev
		}
	}
	debugMsg "primer_next $kind $chan ($ev): $newS"
	return $newS
}

# ==========================================

proc try_instantiate {kind ev chan} {
	set result {}
	set t [event2term $ev]
	switch -- $kind {
	  input -
	  output {
		foreach el [mr_list [list $kind ] [list $chan]] {
			set el_kind [lindex $el 0]
			set el_chan [lindex $el 1]
			# debugMsg $el
			set mev [smile_event2event [lindex $el 2]]
			set mt [event2term $mev]
			set unification [unify $mt $t]
			if {[lindex $unification 0]} {
				set smile_events [lindex $el 3]
				set tmp_result {}
				foreach sm_el $smile_events {
					# debugMsg $sm_el
					set sm_t [event2term [smile_event2event [show_event $sm_el]]]
					set sm_unification [unify $sm_t $t [get_free_variables $sm_el]]
					if {[lindex $sm_unification 0]} {
						lappend tmp_result [list $sm_el [lindex $sm_unification 1]]
					}
				}
				lappend result [list $el [lindex $unification 1] $tmp_result]
			}
		}
	  } inputsuspension -
	    outputsuspension {
		foreach el [mr_list [list $kind ] [list $chan]] {
			set el_kind [lindex $el 0]
			set el_chan [lindex $el 1]
			# debugMsg $el
		  	set smile_events [lindex $el 3]
		  	set tmp_result {}
			foreach sm_el $smile_events {
				lappend tmp_result [list $sm_el {}]
			}
			lappend result [list $el {} $tmp_result]
		}
	  }
	}
	return $result
}

proc try_predicates {trylist} {
	set result {}
	foreach m $trylist {
		set uni_smile_events [lindex $m 2]
		foreach e $uni_smile_events {
			lappend result [make_predicates	$e]
		}
	}
	return $result
}

proc make_predicates {unif} {
	set result ""
	set ev [lindex $unif 0]
	set bindings [lindex $unif 1]
	foreach b $bindings {
		set v [lindex $b 0]
		set e [lindex $b 1] ;# single expression (single experiment-option)
		set t [list $e] ;# encapsulate single experiment in a term
		set s [term2event $t]
		set p "$v = $s; "
		append result $p
	}
	return [list $ev $result]
}

proc get_free_variables {ev} {
	set result {}
	set free_vars [free_variables $ev]
	foreach fv $free_vars {
		lappend result [lindex $fv 0]
	}
	return $result
}

