/***** trojka: tan-action.c *****/

/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */
/* This software is for educational purposes only.                        */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.att.com          */

/*	Modified code and additional routines for the trojka analyser	*/
/*	No guarantee is expressed or implied!				*/
/*									*/
/* No permission is given to distribute the modified code and		*/
/* additional routines without permission of the author.		*/
/*									*/
/* Modified code and additional routines written by Rene G. de Vries	*/
/*									*/
/* trojka analyser action handler					*/
/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/
/*----------------------------------------------------------------------*/

#include <stdio.h>

#ifdef TANSTATIC
#include "tan-action.h"
#endif

/* prototypes (pan.c */
char    *emalloc(unsigned);     /* never released or reallocated memory proc */

/* Global declarations */

IActionT setAction;		/* help to pass to trojka.h */
IActionT *abag		= NULL;	/* Global bag of unused actionvectors */
IActionT *aroot		= NULL; /* root of actionvector-list */
short	 actionident	= 0;	/* global action-counter */

void
Addaction(uchar queue, AtypeT atype, char *text)
{	int	i;
	IActionT *tmp;
	for (tmp = aroot;tmp;tmp = tmp->nxt) {
		if (queue == tmp->Queue && \
		   (memcmp(tmp->sfield, G_sfield,  sizeof(fieldT)*G_nrfields))==0)
		    for (i=0;i<G_nrfields;i++) {
			if (tmp->sfield[i]==solid && G_vfield[i]!=tmp->vfield[i]) break;
			if (i==G_nrfields-1) return; /* double action */
			}
	
	}
	/* oke, new action */
	if (!abag) tmp = (IActionT *) emalloc(sizeof(IActionT)); 
	else	{ /* use an old one */
		tmp = abag;
		abag = tmp->nxt;
		}
	tmp->nxt = aroot;
	aroot = tmp;
	tmp->aident = ++actionident;
	tmp->atype = atype;
	tmp->Queue = queue;
	tmp->string = text;
	tmp->Qtype = G_Qtype;
	tmp->nr_fields = G_nrfields;
	memcpy(tmp->sfield,G_sfield,sizeof(fieldT)*G_nrfields);
	memcpy(tmp->vfield,G_vfield,sizeof(int)*G_nrfields);
}

void
ClearAction(void)
{
	IActionT *tmp;
	if (aroot) {
		for  (tmp = aroot; tmp->nxt; tmp=tmp->nxt);
		tmp->nxt = abag;
		abag = aroot;
		}
	aroot = NULL;
	actionident = 0;
}
				
void
PrtAction(FILE *out, int actionnr)
{
	IActionT *tmp;
	for (tmp=aroot; tmp->aident!=(short) actionnr;tmp=tmp->nxt);
	fprintf(out, "%s %-25s\t",(tmp->atype==input)?"input: ":"output:",
		tmp->string);
	if (tmp->atype==input)
		qrecvprt(out,tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);
	else 
		qsendprt(out,tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);
}	

ActionT
SetAction(int actionnr)
{	ActionT	 Result;
	IActionT *tmp;
	int i;

	for (tmp=aroot; tmp->aident!=(short) actionnr;tmp=tmp->nxt);
	if (tmp->atype==input)
		qrecvset(tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);
	else 
		qsendset(tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);

	Result.atype = setAction.atype = tmp->atype;
	Result.Queue = setAction.Queue = tmp-> Queue;
	Result.nr_fields = setAction.nr_fields = tmp->nr_fields;
	for(i=0;i<Mpars;i++) {
		setAction.vfield[i] = fldval[i+2];
		setAction.sfield[i] = solid;
	}
	Result.sfield = setAction.sfield;
	Result.vfield = setAction.vfield;
#if 0
	fprintf(stderr, "execute action [%d]: %-25s\t( ",actionnr,tmp->string);
		fprintf(stderr, "%d",fldval[2]);
		for(i=2;i<=abs(fldval[0]);i++) fprintf(stderr, ", %d",fldval[i+1]);
		fprintf(stderr, " )\n"); 
#endif
	return Result;
}


ActionT
GetAction(int actionnr)
{	ActionT	 Result;
	IActionT *tmp;
	int i;

	for (tmp=aroot; tmp->aident!=(short) actionnr;tmp=tmp->nxt);
	Result.atype = tmp->atype;
	Result.Queue = tmp-> Queue;
	Result.nr_fields = tmp->nr_fields;
	Result.sfield = tmp->sfield;
	Result.vfield = tmp->vfield;

	return Result;
}
