/***** trojka: tan-action.h *****/

/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */
/* This software is for educational purposes only.                        */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.att.com          */

/*	Modified code and additional routines for the trojka analyser	*/
/*	No guarantee is expressed or implied!				*/
/*									*/
/* No permission is given to distribute the modified code and		*/
/* additional routines without permission of the author.		*/
/*									*/
/* Modified code and additional routines written by Rene G. de Vries	*/
/*									*/
/* trojka analyser action handler					*/
/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/
/*----------------------------------------------------------------------*/

#ifndef H_TAN_ACTION
#define H_TAN_ACTION

#ifdef TANSTATIC
#include "trojka.h"
#endif

#if 0
	external usage of global variables from pan.c:
	G_Qtype, G_Sfields, G_Vfields, Mpars
#endif

#ifndef uchar
#define uchar   unsigned char
#endif

/* exported datatypes */
typedef struct IActionT {	/* datatype to store an internal action */ 

	short		aident;		/* action identifier */
	AtypeT		atype;		/* actiontype	*/
	uchar		Queue;		/* queue number */
	uchar		Qtype;		/* queue type */
	char		*string;	/* ascii action string */
	short		nr_fields;	/* nr of field */
	fieldT		sfield[Mpars];	/* field settting tag */
	int		vfield[Mpars];	/* field value  */
	struct IActionT	*nxt;		/* linked list */

} IActionT;



void
Addaction(uchar /*in*/, AtypeT /*in*/, char* /*in*/);
/* add current selected action (G_vars) and parameters to actionlist */


void
ClearAction(void);
/* remove all actions from the current actionlist */
				
void
PrtAction(FILE* , int /* actionnr */);
/* print action actionnr in text to output file out */


ActionT
SetAction(int /* actionnr */);
/* set trojka-engine to action actionnr (with parameter generation) */
/* return an action with the valid parameters */


ActionT
GetAction(int);
/* return action identified by the parameter */

#endif
