%{
/***********************************************************************/
/*									*/
/*									*/
/* Derived from lotos_lex_ssl and adtl.l.				*/
/*									*/
/***********************************************************************/

#if ! (defined(lint) || defined(SABER) || defined(CODECENTER))
static char exprl_lAccesSid[] = "@(#)$Id: exprl.l,v 1.4 2000/03/24 12:41:47 belinfan Exp $";
#endif

#include "expr.h"
#include "expry.h"
#include "k.h"

# undef EOF
# define EOF		0

#ifndef FLEX_SCANNER
/*** we now use a standard LEX *****/
# undef getc
# undef putc
# undef output
# undef input
# undef unput

# define getc(f)	GETC()
# define putc(c,f)	/* nothing yet ?! */
# define output(c)	putc(c,yyout)
# define input()	(yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))
# define unput(c)	{yytchar=(c);UNPUT(yytchar);*yysptr++=yytchar;}

/* FLEX needs this routine, but LEX does not generate it!! */
#ifdef KC_USE_PROTOTYPES
void yyrestart ( FILE *input_file )
#else 
void yyrestart ( input_file ) FILE *input_file;
#endif 
	{ return; }

#else
/* we use FLEX */
int yylineno = 0;
#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
  { \
	int c = GETC(); \
	result = (c == EOF) ? YY_NULL : (buf[0]=c, 1); \
  }

#endif

# ifdef			LEXDEBUG
# define allprint(c)	printf(":%d",c)
# define sprint(s)	printf(s)
# endif			/*LEXDEBUG*/

char GETC()
    {
    switch( *input_pointer )
	{
	case '\n':	yycolno = 1;
			yylineno++;
			yyoffset++;
			return *input_pointer++;
	case '\t':	yycolno += 8-yycolno%8;
			yyoffset++;
			return *input_pointer++;
	case '\0':	return EOF;
	default:	yycolno++;
			yyoffset++;
			return *input_pointer++;
	}
    }

void UNPUT(c)
    char c;
    {
    switch( c )
	{
	case '\n':	
			yylineno--;
			break;
	case '\t':	break;
	case '\0':	break;
	default:	break;
	}
    }

	
/* LEXEMES */

/* comments like (*--A*), (*--A...*), A an uppercase character,
 * will be thrown away
 */

/* in state COMMENT_NAME_OPT we expect either a comment or a whitespace character ...
 * NOTHING ELSE (so we must be very sure that no other separators are allowed wherever we
 * switch to the COMMENT_NAME_OPT state.
 * If other separators are allowed, then we must 'enable' their regular expressions
 * in this state.
 */

/*
 * NOTE: if we use our own lexical optimizer we can specify case insensitive keywords
 * in the following way: the regular expression in the lexeme should be
 * a *QUOTED* string, directely followed by the *NOT-QUOTED* charactersequence {*CI*}
 * as is SPEC : SpecLex< "specification"{*CI*}
 * The character sequence {*CI*} , if used in the contex as above, will be ignored
 * by lex (at least on Sun and Hp workstations)(however, it will warn that {*CI*} is not defined),
 * which should make the stuff still
 * work without the special lexical optimizer. However, the keywords will then no
 * longer be case insensitive.
 *
 * In the lines below we therefore added the special caharacter sequence {*CI*}
 * to the *first* lexeme for a phylum: the result is that without the
 * special lexical optimizer the stuff still works; the special lexical optimizer
 * will ignore the case sensitive versions of a keywords following one that was declared
 * as case insensitive (however, it will let you know that some regular ecpressions 
 * are subsumed by realier defined ones.
 */

%}

%START COMMENT_NAME_OPT NO_WHITESPACE

%e 15000
%p 19999
%a 19999
%n 12000
%o 19999

%%

%{
/*----------------------------------------------------------------------*/
/* 6.1.? LAYOUT		 						*/
/*----------------------------------------------------------------------*/
%}

[\1-\40\177\t\n] 								{			/* return WHITESPACE		*/ ;}
<COMMENT_NAME_OPT>[\t\ ]*"(*\ "[a-zA-Z]([a-zA-Z0-9_]*[a-zA-Z0-9])?"\ *)"	{BEGIN 0;		/* return WHITESPACE		*/ ;}
<COMMENT_NAME_OPT>"(*"								{BEGIN NO_WHITESPACE;	/* return START_COMMENT		*/ ;}
<COMMENT_NAME_OPT>[\1-\40\177\t\n]						{BEGIN 0;		/* return WHITESPACE		*/ ;}
"(*-"(("-"[A-Z])|[EWI])								{BEGIN NO_WHITESPACE;	/* return START_NO_COMMENT	*/ ;}
"(*"										{BEGIN NO_WHITESPACE;	/* return START_COMMENT		*/ ;}
<NO_WHITESPACE>"\n" 								{			/* return CLINEBREAK		*/ ;}
<NO_WHITESPACE>[^\)\n\*][^\n\*]* 						{			/* return CPART			*/ ;}
<NO_WHITESPACE>"*" 								{			/* return CSTAR			*/ ;}
<NO_WHITESPACE>")" 								{			/* return CRPAR			*/ ;}
<NO_WHITESPACE>"*)"								{BEGIN 0;		/* return END_COMMENT		*/ ;}

%{
/*----------------------------------------------------------------------*/
/* 6.1.3 RESERVED SYMBOLS 						*/
/*----------------------------------------------------------------------*/
%}
%{
/*----------------------------------------------------------------------*/
/* 6.1.3.1 WORD-SYMBOLS							*/
/*----------------------------------------------------------------------*/
%}

"ofsort"			{return OFSORT;}
"OFSORT" 			{return OFSORT;}
"Ofsort" 			{return OFSORT;}
":"					{return OFSORT;}
"of"				{return OFSORT;}
"OF"				{return OFSORT;}
"Of"				{return OFSORT;}

%{
/*----------------------------------------------------------------------*/
/* 6.1.3.2 SPECIAL-SYMBOLS						*/
/*----------------------------------------------------------------------*/
%}

"=" 					{return EQUAL;}
";" 					{return SEMICOLON;}
"," 					{return COMMA;}
"(" 					{return OPEN_PARENTHESIS;}
")" 					{return CLOSE_PARENTHESIS;}
"*"					{return STAR;}
"?"					{return QUERY;}
"!"					{return EXCLAM;}
"["					{return OPEN_BRACE;}
"]"					{return CLOSE_BRACE;}

%{
/*----------------------------------------------------------------------*/
/* 6.1.4 IDENTIFIERS							*/
/*----------------------------------------------------------------------*/
%}
%{
/* Underscore may follow underscore */
%}

[a-zA-Z]([a-zA-Z0-9_]*[a-zA-Z0-9])?	{yylval.yt_nocasestring = mknocasestring(yytext); return IDENTIFIER;}
[-+*#%&./<=>@\\	{}\^~]+			{yylval.yt_nocasestring = mknocasestring(yytext); return SPECIAL_IDENTIFIER;}
[0-9]([a-zA-Z0-9_]*[a-zA-Z0-9])?	{yylval.yt_nocasestring = mknocasestring(yytext); return SPECIAL_IDENTIFIER;}

%{
/************************************************************************/
/* SMILE LEX								*/
/************************************************************************/
%}
