# =========================================================================
#
# Error handling
#

proc do_cleanup {} {
	global iutinfo specinfo sidinfo
	if {![info exists specinfo]} {
		return
	}
	if {![info exists specinfo(primerids)]} {
		return
	}
	foreach id $specinfo(primerids) {
		if {[info exists sidinfo(spec,$id)]} {
			if {[string length $sidinfo(spec,$id)] > 0} {
				send -i $sidinfo(spec,$id) "C_QUIT\r"
			}
			foreach pid [list $specinfo(pid,$id)] {
				send_user "Cleaning up: $pid\n"
				if {[string length $pid]} {
					if {[catch {exec kill $pid} foo]} {
						send_user "kill $pid: $foo\n"
					}
					if {[catch {exec kill -9 $pid} foo]} {
						send_user "kill-9 $pid: $foo\n"
					}
				}
			}
		}
	}
}
proc clean_exit { {r 0} } {
	do_cleanup
	exit $r
}
proc fatal { {s ""} } {
	set l [string length $s]
	set timeout 1
	expect
	if {$l != 0} {
		if {[string compare [string index $s [expr $l - 1]] "\n"] == 0} {
			send_user "Fatal: $s"
		} else {
			send_user "Fatal: $s\n"
		}
	}
	clean_exit 1
}

# =========================================================================
