#! @PERL@

$| = 1; # do not buffer!

while(<>) {
	chomp;
	if (/^des[ 	]*\(([0-9]+)[ 	]*,[ 	]*([0-9]+)[ 	]*,[ 	]*[0-9]+[ 	]*\)/)  {
		$ini = $1;
		$nnodes = $2;
		$nedges = $3;
	} elsif (/^\([ 	]*([0-9]+)[ 	]*,[ 	]*(.*)[ 	]*,[ 	]*([0-9]+)[ 	]*\)$/) {
		$s = $1;
		$l = $2;
		$d = $3;
		$in{$d}++;
		$out{$s}++;
		$n{$s} = 1;
		$n{$d} = 1;
		push(@trans, join($;, ($s, $l, $d)));
	}
}

print "fan_in(0)\n";
print "fan_out(0)\n";
print "node_nr(0)\n";
print "---\n";

# subconsiencly we know $ini == 0
# and we depend on it here, I think,
# or at least on the fact that we know that
# there can be a node 0
$i = $ini;
while ($i < $nnodes) {
	if ($in{$i} eq '') {
		$in{$i} = 0;
	}
	if ($out{$i} eq '') {
		$out{$i} = 0;
	}
	print $in{$i}." ".$out{$i}." ".node($i)."\n";
	$i++;
}
print "---\n";
foreach $t (@trans) {
	($s, $l, $d) = split($;, $t);
	print node($s)." ".node($d)." ".$l."\n";
}

# compensate for the fact that aut has origin 0
# whereas fms uses origin 1 (and breaks with origin 0?)
sub node {
	my($n) = @_;
	return $n+1;
}

