#! /bin/sh

FILES=""
MLEVEL="0"
LMODE="async"
JARARACYPATH="@scriptdir@"
export LEFTYPATH

usage='echo "usage: jararacy [-V] [-lm (sync|async)] [-el (0|1)] [-t tile] [-c control] -p pipe <filename>"'
control='""'
title='""'

if [ "x$DOTTYOPTIONS" != "x" ]; then
    set -- $DOTTYOPTIONS $*
fi

while [ "x$1" != 'x' ]; do
    case $1 in
    -V)
        echo "jararacy version 0.1"
        shift
        ;;
    -f)
        shift
        loadfile=$1
        shift
        ;;
    -lm)
        shift
        LMODE=$1
        if [ "x$LMODE" != 'xsync' -a "x$LMODE" != 'xasync' ]; then
            $usage
            exit 1
        fi
        shift
        ;;
    -el)
        shift
        MLEVEL=$1
        if [ "x$MLEVEL" != 'x0' -a "x$MLEVEL" != 'x1' ]; then
            $usage
            exit 1
        fi
        shift
        ;;
    -c)
        shift
        control=\"$1\"
        shift
        ;;
    -p)
        shift
        pipe=\"$1\"
        shift
        ;;
    -t)
        shift
        title=\"$1\"
        shift
        ;;
    -)
        FILES=`echo $FILES \"$1\"`
        shift
        ;;
    -*)
        $usage
        exit 1
        ;;
    *)
        FILES=`echo $FILES \"$1\"`
        shift
        ;;
    esac
done

if [ "x$DOTTYPATH" != 'x' ]; then
    LEFTYPATH="$DOTTYPATH:$LEFTYPATH"
fi
if [ "x$JARARACYPATH" != 'x' ]; then
    LEFTYPATH="$JARARACYPATH:$LEFTYPATH"
fi

CMDS=""

CMDS="dotty.protogt.layoutmode = '$LMODE';"

CMDS=`echo $CMDS dotty.mlevel = $MLEVEL";"`

if [ "x$FILES" = 'x' ]; then
    FILES=null
fi
FUNC="fa.main"
for i in $FILES; do
    CMDS=`echo $CMDS $FUNC \($i, $pipe, $control, $title \)";"`
done

leftypath=`which lefty`
if [ ! -f "$leftypath" ]; then
    echo "dotty: cannot locate the lefty program"
    echo "       make sure that your path includes"
    echo "       the directory containing dotty and lefty"
    exit 1
fi

echo "LEFTY.reverseVideo: false" | xrdb -merge

exec $leftypath -e "
load ('jararacy.lefty');
checkpath = function () {
    if (tablesize (dotty) > 0)
        remove ('checkpath');
    else {
        echo ('dotty: cannot locate the dotty scripts');
        echo ('       make sure that the environment variable LEFTYPATH');
        echo ('       is set to the directory containing dotty.lefty');
        exit ();
    }
};
checkpath ();
fa.init ();
$CMDS
txtview ('off');
echo('STARTED');
"
